Overview | Package | Class | Tree | Deprecated | Index | Help
| Spring Framework
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

## org.springframework.util
Class AutoPopulatingList<E>

    java.lang.Object
      org.springframework.util.AutoPopulatingList<E>

All Implemented Interfaces:
  java.io.Serializable, java.lang.Iterable<E>, java.util.Collection<E>, java.util.List<E>

    public class AutoPopulatingList<E>

extends java.lang.Object
implements java.util.List<E>, java.io.Serializable

Simple `List` wrapper class that allows for elements to be automatically populated as they are requested. This is particularly useful for data binding to `Lists`, allowing for elements to be created and added to the `List` in a "just in time" fashion.

Note: This class is not thread-safe. To create a thread-safe version, use the `Collections.synchronizedList(java.util.List)` utility methods.

Inspired by `LazyList` from Commons Collections.

Since:
  2.0
Author:
  Rob Harrop, Juergen Hoeller
See Also:
  Serialized Form

Nested Class Summary
`static interface` | `AutoPopulatingList.ElementFactory<E>` Factory interface for creating elements for an index-based access data structure such as a `List`.
`static class` | `AutoPopulatingList.ElementInstantiationException` Exception to be thrown from ElementFactory.

Constructor Summary
`AutoPopulatingList(AutoPopulatingList.ElementFactory<E> elementFactory)` Creates a new `AutoPopulatingList` that is backed by a standard `ArrayList` and creates new elements on demand using the supplied `AutoPopulatingList.ElementFactory`.
`AutoPopulatingList(java.lang.Class<? extends E> elementClass)` Creates a new `AutoPopulatingList` that is backed by a standard `ArrayList` and adds new instances of the supplied `element Class` to the backing `List` on demand.
`AutoPopulatingList(java.util.List<E> backingList, AutoPopulatingList.ElementFactory<E> elementFactory)` Creates a new `AutoPopulatingList` that is backed by the supplied `List` and creates new elements on demand using the supplied `AutoPopulatingList.ElementFactory`.
`AutoPopulatingList(java.util.List<E> backingList, java.lang.Class<? extends E> elementClass)` Creates a new `AutoPopulatingList` that is backed by the supplied `List` and adds new instances of the supplied `element Class` to the backing `List` on demand.

Method Summary
`boolean` | `add(E o)`
`void` | `add(int index, E element)`
`boolean` | `addAll(java.util.Collection<? extends E> c)`
`boolean` | `addAll(int index, java.util.Collection<? extends E> c)`
`void` | `clear()`
`boolean` | `contains(java.lang.Object o)`
`boolean` | `containsAll(java.util.Collection c)`
`boolean` | `equals(java.lang.Object other)`
`E` | `get(int index)` Get the element at the supplied index, creating it if there is no element at that index.
`int` | `hashCode()`
`int` | `indexOf(java.lang.Object o)`
`boolean` | `isEmpty()`
`java.util.Iterator<E>` | `iterator()`
`int` | `lastIndexOf(java.lang.Object o)`
`java.util.ListIterator<E>` | `listIterator()`
`java.util.ListIterator<E>` | `listIterator(int index)`
`E` | `remove(int index)`
`boolean` | `remove(java.lang.Object o)`
`boolean` | `removeAll(java.util.Collection<?> c)`
`boolean` | `retainAll(java.util.Collection<?> c)`
`E` | `set(int index, E element)`
`int` | `size()`
`java.util.List<E>` | `subList(int fromIndex, int toIndex)`
`java.lang.Object[]` | `toArray()`
`
`<T> T[]`
` | `toArray(T[] a)`

Methods inherited from class java.lang.Object
`clone, finalize, getClass, notify, notifyAll, toString, wait, wait, wait`

Constructor Detail

### AutoPopulatingList

    public AutoPopulatingList(java.lang.Class<? extends E> elementClass)

  Creates a new `AutoPopulatingList` that is backed by a standard `ArrayList` and adds new instances of the supplied `element Class` to the backing `List` on demand.

### AutoPopulatingList

    public AutoPopulatingList(java.util.List<E> backingList,
                              java.lang.Class<? extends E> elementClass)

  Creates a new `AutoPopulatingList` that is backed by the supplied `List` and adds new instances of the supplied `element Class` to the backing `List` on demand.

### AutoPopulatingList

    public AutoPopulatingList(AutoPopulatingList.ElementFactory<E> elementFactory)

  Creates a new `AutoPopulatingList` that is backed by a standard `ArrayList` and creates new elements on demand using the supplied `AutoPopulatingList.ElementFactory`.

### AutoPopulatingList

    public AutoPopulatingList(java.util.List<E> backingList,
                              AutoPopulatingList.ElementFactory<E> elementFactory)

  Creates a new `AutoPopulatingList` that is backed by the supplied `List` and creates new elements on demand using the supplied `AutoPopulatingList.ElementFactory`.

Method Detail

### add

    public void add(int index,
                    E element)

  Specified by:
    `add` in interface `java.util.List<E>`

### add

    public boolean add(E o)

  Specified by:
    `add` in interface `java.util.Collection<E>`
  Specified by:
    `add` in interface `java.util.List<E>`

### addAll

    public boolean addAll(java.util.Collection<? extends E> c)

  Specified by:
    `addAll` in interface `java.util.Collection<E>`
  Specified by:
    `addAll` in interface `java.util.List<E>`

### addAll

    public boolean addAll(int index,
                          java.util.Collection<? extends E> c)

  Specified by:
    `addAll` in interface `java.util.List<E>`

### clear

    public void clear()

  Specified by:
    `clear` in interface `java.util.Collection<E>`
  Specified by:
    `clear` in interface `java.util.List<E>`

### contains

    public boolean contains(java.lang.Object o)

  Specified by:
    `contains` in interface `java.util.Collection<E>`
  Specified by:
    `contains` in interface `java.util.List<E>`

### containsAll

    public boolean containsAll(java.util.Collection c)

  Specified by:
    `containsAll` in interface `java.util.Collection<E>`
  Specified by:
    `containsAll` in interface `java.util.List<E>`

### get

    public E get(int index)

  Get the element at the supplied index, creating it if there is no element at that index.

  Specified by:
    `get` in interface `java.util.List<E>`

### indexOf

    public int indexOf(java.lang.Object o)

  Specified by:
    `indexOf` in interface `java.util.List<E>`

### isEmpty

    public boolean isEmpty()

  Specified by:
    `isEmpty` in interface `java.util.Collection<E>`
  Specified by:
    `isEmpty` in interface `java.util.List<E>`

### iterator

    public java.util.Iterator<E> iterator()

  Specified by:
    `iterator` in interface `java.lang.Iterable<E>`
  Specified by:
    `iterator` in interface `java.util.Collection<E>`
  Specified by:
    `iterator` in interface `java.util.List<E>`

### lastIndexOf

    public int lastIndexOf(java.lang.Object o)

  Specified by:
    `lastIndexOf` in interface `java.util.List<E>`

### listIterator

    public java.util.ListIterator<E> listIterator()

  Specified by:
    `listIterator` in interface `java.util.List<E>`

### listIterator

    public java.util.ListIterator<E> listIterator(int index)

  Specified by:
    `listIterator` in interface `java.util.List<E>`

### remove

    public E remove(int index)

  Specified by:
    `remove` in interface `java.util.List<E>`

### remove

    public boolean remove(java.lang.Object o)

  Specified by:
    `remove` in interface `java.util.Collection<E>`
  Specified by:
    `remove` in interface `java.util.List<E>`

### removeAll

    public boolean removeAll(java.util.Collection<?> c)

  Specified by:
    `removeAll` in interface `java.util.Collection<E>`
  Specified by:
    `removeAll` in interface `java.util.List<E>`

### retainAll

    public boolean retainAll(java.util.Collection<?> c)

  Specified by:
    `retainAll` in interface `java.util.Collection<E>`
  Specified by:
    `retainAll` in interface `java.util.List<E>`

### set

    public E set(int index,
                 E element)

  Specified by:
    `set` in interface `java.util.List<E>`

### size

    public int size()

  Specified by:
    `size` in interface `java.util.Collection<E>`
  Specified by:
    `size` in interface `java.util.List<E>`

### subList

    public java.util.List<E> subList(int fromIndex,
                                     int toIndex)

  Specified by:
    `subList` in interface `java.util.List<E>`

### toArray

    public java.lang.Object[] toArray()

  Specified by:
    `toArray` in interface `java.util.Collection<E>`
  Specified by:
    `toArray` in interface `java.util.List<E>`

### toArray

    public <T> T[] toArray(T[] a)

  Specified by:
    `toArray` in interface `java.util.Collection<E>`
  Specified by:
    `toArray` in interface `java.util.List<E>`

### equals

    public boolean equals(java.lang.Object other)

  Specified by:
    `equals` in interface `java.util.Collection<E>`
  Specified by:
    `equals` in interface `java.util.List<E>`
  Overrides:
    `equals` in class `java.lang.Object`

### hashCode

    public int hashCode()

  Specified by:
    `hashCode` in interface `java.util.Collection<E>`
  Specified by:
    `hashCode` in interface `java.util.List<E>`
  Overrides:
    `hashCode` in class `java.lang.Object`

Overview | Package | Class | Tree | Deprecated | Index | Help
| Spring Framework
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD